import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.ArrayList;

/**
 * Write a description of class Alligator here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Turtle extends Actor
{
    /**
     * Act - do whatever the Alligator wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    private int stepCounter;
    
    public void act() 
    {
       this.navigation();
       this.captureStarfish();
       //int score;
       stepCounter++;
       this.spawnStarfish();
       this.shoot();
    }    
    
    public void navigation()
    {
       if(Greenfoot.isKeyDown("left"))
        {
            this.setRotation(180);
            this.move(10);
        }
       else if(Greenfoot.isKeyDown("right"))
        {
            this.setRotation(0);
            this.move(10);
        }
       else if(Greenfoot.isKeyDown("down"))
        {
            this.setRotation(90);
            this.move(10);
        }
       else if(Greenfoot.isKeyDown("up"))
        {
            this.setRotation(270);
            this.move(10);
        } 
    }
    
    public void spawnStarfish()
    {
        World w = this.getWorld();
        ArrayList<Jellyfish> starfishList = (ArrayList) w.getObjects(Jellyfish.class);
        if(starfishList.size() == 3)
        {
            //System.exit(1);
        }
        
        if (starfishList.size() < 3)
        {
            if ((stepCounter % 100) == 0 )//test if stepCounter is a mulitible of 300;
            {
                Jellyfish anJellyfish = new Jellyfish();
                
                int width = w.getWidth() ;
                int height = w.getHeight();
                
                int randX = Greenfoot.getRandomNumber(600);
                int randY = Greenfoot.getRandomNumber(400);
                w.addObject(anJellyfish,randX,randY);
            }
        }
    }
    
    int score = 0;
    public void captureStarfish()
    {
        if(this.isTouching(Jellyfish.class))
        {
            Score.update();
            this.removeTouching(Jellyfish.class);
            //score = score+1;
            //System.out.println("Score: " + (score));
        }
    }
        
       
        
    public void shoot()
    {
        if(Greenfoot.isKeyDown("space"))
        {
            if (Bullet.getOK() == true)
            {
                Bullet b = new Bullet();
                int myX = this.getX();
                int myY = this.getY();
                int myRotation = this.getRotation();
                b.setRotation(myRotation);
                
                World w = this.getWorld();
                w.addObject(b, myX, myY);  
                Bullet.resetOK();
            }
        }
    }
}
